function [ r ] = PSNR( img_orig,img_rest,pad )
%PSNR : Calculates the peak to noise signal ratio between original imgage
% img_orig e restored image img_rest. 
%   
% img_orig and img_rest must have same size.
% Pad is the number of pixels to be cropped around each of the images.

[n,m,d] = size(img_orig);  

img_orig_pad = img_orig((pad+1):(n-pad),(pad+1):(m-pad),:);
img_rest_pad = img_rest((pad+1):(n-pad),(pad+1):(m-pad),:);

[n,m,d] = size(img_orig_pad);  

diff = (img_orig_pad - img_rest_pad).^2;
MSE = (1/(m*n*d)).*sum(diff(:));
i_orig_max = max(img_orig_pad(:));

r = 10*log10((i_orig_max^2)/MSE);

end

