function [ Xr, L ] = averageIntensity( Y, numSuperpixels )
    
    B = size(Y,3);
    
    avg = mean(Y,3);    
    [L,N] = superpixels(avg,numSuperpixels);
    
    Xr = zeros(size(Y));

    for i=1:N

        maskedAvg = avg;
        maskedAvg(L~=i) = 0;
        pxls = zeros(size(Y(:,:,1)));
        pxls(L==i) = 1;
        avgInt = sum(pxls(:).*avg(:));
        meanAvg = avgInt./sum(pxls(:));
        
        pxls3 = repmat(pxls,[1,1,B]);
        pxsInt = sum(sum(pxls3.*Y,1),2);
        meanBandInt = pxsInt./sum(pxls(:));
        Xr = Xr + maskedAvg.*(meanBandInt./meanAvg);
        
    end

end

